<script setup lang="ts">
import { useRouter } from 'vue-router'
import type { ExposedForm } from '~/types/form'
import Action from '~/components/pub/my-ui/nav-footer/ba-dr-su.vue'
import { handleActionSave,} from '~/handlers/supporting-document.handler'
import { toast } from '~/components/pub/ui/toast'
import Confirmation from '~/components/pub/my-ui/confirmation/confirmation.vue'
import { DocumentUploadSchema } from '~/schemas/document-upload.schema'
import { getDetail } from '~/services/supporting-document.service'

const props = withDefaults(defineProps<{ 
  encounter_id: number 
  record_id: number 
}>(), {
  
})

// form related state
const docId = props.record_id
const inputForm = ref<ExposedForm<any> | null>(null)
// #endregion

// #region State & Computed
const router = useRouter()
const isConfirmationOpen = ref(false)
const { user } = useUserStore()
const initialValues = {
  officer: user.user_name,
}
// #endregion

// #region Lifecycle Hooks
onMounted(async () => {
  const result = await getDetail(docId)
  if (result.success) {
    inputForm.value?.setValues(result.body.data)
  }
})
// #endregion

// #region Functions
function goBack() {
  router.go(-1)
}

async function handleConfirmAdd() {
  const inputData = await composeFormData()
  let createdDataId = 0

  // const response = await handleActionSave(
  //   inputData,
  //   () => { },
  //   () => { },
  //   toast,
  // )

  // const data = (response?.body?.data ?? null)
  // if (!data) return
  // createdDataId = data.id

  // // // If has callback provided redirect to callback with patientData
  // if (props.callbackUrl) {
  //   navigateTo(props.callbackUrl + '?control-letter-id=' + inputData.id)
  // }
  // goBack()
}

async function composeFormData(): Promise<any> {
  const [inputFormState,] = await Promise.all([
    inputForm.value?.validate(),
  ])

  const results = [inputFormState]
  const allValid = results.every((r) => r?.valid)

  // exit, if form errors happend during validation
  if (!allValid) return Promise.reject('Form validation failed')

  const formData = inputFormState?.values
  formData.encounter_id = props.encounter_id
  return new Promise((resolve) => resolve(formData))
}
// #endregion region

// #region Utilities & event handlers
async function handleActionClick(eventType: string) {
  if (eventType === 'submit') {
    isConfirmationOpen.value = true
  }

  if (eventType === 'back') goBack()
}

function handleCancelAdd() {
  isConfirmationOpen.value = false
}
// #endregion

// #region Watchers
// #endregion
</script>

<template>
  <div class="mb-5 border-b border-b-slate-300 pb-3 text-lg font-semibold xl:text-xl">
    <h1>Update Upload Dokumen</h1>
  </div>
  <AppDocumentUploadEntryForm
    ref="inputForm"
    :schema="DocumentUploadSchema"
    :initial-values="initialValues"
  />

  <div class="my-2 flex justify-end py-2">
    <Action :enable-draft="false" @click="handleActionClick" />
  </div>

  <Confirmation v-model:open="isConfirmationOpen"
    title="Simpan Data"
    message="Apakah Anda yakin ingin menyimpan data ini?"
    confirm-text="Simpan"
    @confirm="handleConfirmAdd"
    @cancel="handleCancelAdd" />
</template>

<style scoped>
/* component style */
</style>
